Index: libdvdcss/ioctl.c
===================================================================
--- libdvdcss/ioctl.c	(revision 27458)
+++ libdvdcss/ioctl.c	(working copy)
@@ -49,9 +49,11 @@
 #   include <os2.h>
 #   include <sys/ioctl.h>
 #else
+#ifndef GEKKO
 #   include <netinet/in.h>
 #   include <sys/ioctl.h>
 #endif
+#endif
 
 #ifdef DVD_STRUCT_IN_SYS_CDIO_H
 #   include <sys/cdio.h>
@@ -269,6 +271,8 @@
 
     *pi_copyright = p_buffer[ 4 ];
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -442,6 +446,8 @@
 
     memcpy( p_key, p_buffer + 4, DVD_DISCKEY_SIZE );
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -606,6 +612,8 @@
 
     memcpy( p_key, p_buffer + 5, DVD_KEY_SIZE );
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -730,6 +738,8 @@
 
     *pi_agid = p_buffer[ 7 ] >> 6;
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -864,6 +874,8 @@
 
     memcpy( p_challenge, p_buffer + 4, DVD_CHALLENGE_SIZE );
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -997,6 +1009,8 @@
 
     *pi_asf = p_buffer[ 7 ] & 1;
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -1126,6 +1140,8 @@
 
     memcpy( p_key, p_buffer + 4, DVD_KEY_SIZE );
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -1237,6 +1253,8 @@
     i_ret = DosDevIOCtl(i_fd, IOCTL_CDROMDISK, CDROMDISK_EXECMD,
                         &sdc, sizeof(sdc), &ulParamLen,
                         NULL, 0, &ulDataLen);
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -1374,6 +1392,8 @@
                          &sdc, sizeof(sdc), &ulParamLen,
                          p_buffer, sizeof(p_buffer), &ulDataLen );
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -1511,6 +1531,8 @@
                          &sdc, sizeof(sdc), &ulParamLen,
                          p_buffer, sizeof(p_buffer), &ulDataLen );
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -1666,6 +1688,8 @@
     *p_mask = p_buffer[ 5 ];
     *p_scheme = p_buffer[ 6 ];
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
@@ -1793,6 +1817,8 @@
                          &sdc, sizeof(sdc), &ulParamLen,
                          p_buffer, sizeof(p_buffer), &ulDataLen );
 
+#elif defined( GEKKO )
+	return -1;
 #else
 #   error "DVD ioctls are unavailable on this system"
 
Index: mplayer.c
===================================================================
--- mplayer.c	(revision 27458)
+++ mplayer.c	(working copy)
@@ -15,7 +15,7 @@
 
 // #include <sys/mman.h>
 #include <sys/types.h>
-#ifndef __MINGW32__
+#if !defined(__MINGW32__) && !defined(GEKKO)
 #include <sys/ioctl.h>
 #include <sys/wait.h>
 #else
@@ -117,6 +117,10 @@
 #include "stream/cache2.h"
 #endif
 
+#ifdef GEKKO
+#include "osdep/plat_gekko.h"
+#endif
+
 //**************************************************************************//
 //             Playtree
 //**************************************************************************//
@@ -726,6 +730,10 @@
   if(how) mp_msg(MSGT_CPLAYER,MSGL_INFO,MSGTR_ExitingHow,how);
   mp_msg(MSGT_CPLAYER,MSGL_DBG2,"max framesize was %d bytes\n",max_framesize);
 
+#ifdef GEKKO
+  plat_deinit (rc);
+#endif
+
   exit(rc);
 }
 
@@ -733,7 +741,7 @@
   exit_player_with_rc(how, 1);
 }
 
-#ifndef __MINGW32__
+#if !defined(__MINGW32__) && !defined(GEKKO)
 static void child_sighandler(int x){  
   pid_t pid;
   while((pid=waitpid(-1,NULL,WNOHANG)) > 0);
@@ -764,7 +772,7 @@
   if(sig_count==6) exit(1);
   if(sig_count>6){
     // can't stop :(
-#ifndef __MINGW32__
+#if !defined(__MINGW32__) && !defined(GEKKO)
     kill(getpid(),SIGKILL);
 #endif
   }
@@ -1241,6 +1249,7 @@
       (int)sh_video->num_frames,
       (int)sh_video->num_frames_decoded);
 
+#ifndef GEKKO
   // CPU usage
   if (sh_video) {
     if (sh_video->timer > 0.5)
@@ -1257,6 +1266,7 @@
     else
       saddf(line, &pos, width, "??,?%% ");
   }
+#endif
 
   // VO stats
   if (sh_video) 
@@ -2556,6 +2566,10 @@
 
 int gui_no_filename=0;
 
+#ifdef GEKKO
+  plat_init (&argc, &argv);
+#endif
+
   InitTimer();
   srand(GetTimerMS());
   
@@ -2891,7 +2905,7 @@
 current_module = NULL;
 
   /// Catch signals
-#ifndef __MINGW32__
+#if !defined(__MINGW32__) && !defined(GEKKO)
   signal(SIGCHLD,child_sighandler);
 #endif
 
@@ -3751,6 +3765,8 @@
 	xscreensaver_heartbeat();
     }
 #endif
+
+#ifndef GEKKO
     if (heartbeat_cmd) {
         static unsigned last_heartbeat;
         unsigned now = GetTimerMS();
@@ -3759,6 +3775,7 @@
             system(heartbeat_cmd);
         }
     }
+#endif
 
     frame_time_remaining = sleep_until_update(&time_frame, &aq_sleep_time);
 
Index: mplayer.spec
===================================================================
--- mplayer.spec	(revision 0)
+++ mplayer.spec	(revision 0)
@@ -0,0 +1,2 @@
+*link_start_rvl:
+ -T mplayer.ld%s
Index: osdep/getch2-gekko.c
===================================================================
--- osdep/getch2-gekko.c	(revision 0)
+++ osdep/getch2-gekko.c	(revision 0)
@@ -0,0 +1,139 @@
+/*
+   getch2_gekko.c - MPlayer TermIO driver for Wii
+
+   Copyright (C) 2008 dhewg
+
+   This library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2 of the License, or (at your option) any later version.
+
+   This library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with this library; if not, write to the
+   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+   Boston, MA 02110-1301 USA.
+*/
+
+#include "config.h"
+#include "keycodes.h"
+#include "input/input.h"
+#include "mp_fifo.h"
+
+#include <gccore.h>
+#include <ogc/lwp_watchdog.h>
+#include <wiiuse/wpad.h>
+
+int screen_width = 80;
+int screen_height = 24;
+char *erase_to_end_of_line = NULL;
+
+static int getch2_status=0;
+
+typedef struct {
+	u16 pad;
+	u32 wpad;
+	int key;
+} pad_map;
+
+static const pad_map pad_maps[] = {
+	{ PAD_BUTTON_A,		WPAD_BUTTON_A,		'a' },
+	{ PAD_BUTTON_B,		WPAD_BUTTON_B,		'b' },
+	{ PAD_BUTTON_X,		WPAD_BUTTON_1,		'x' },
+	{ PAD_TRIGGER_Z,	WPAD_BUTTON_HOME,	'z' },
+	{ PAD_TRIGGER_L,	WPAD_BUTTON_MINUS,	'l' },
+	{ PAD_TRIGGER_R,	WPAD_BUTTON_PLUS,	'r' },
+	{ PAD_BUTTON_LEFT,	WPAD_BUTTON_LEFT,	KEY_LEFT },
+	{ PAD_BUTTON_RIGHT,	WPAD_BUTTON_RIGHT,	KEY_RIGHT },
+	{ PAD_BUTTON_UP,	WPAD_BUTTON_UP,		KEY_UP },
+	{ PAD_BUTTON_DOWN,	WPAD_BUTTON_DOWN,	KEY_DOWN }
+};
+
+static const pad_map pad_maps_mod[] = {
+	{ PAD_BUTTON_A,		WPAD_BUTTON_A,		'A' },
+	{ PAD_BUTTON_B,		WPAD_BUTTON_B,		'B' },
+	{ PAD_BUTTON_X,		WPAD_BUTTON_1,		'X' },
+	{ PAD_TRIGGER_Z,	WPAD_BUTTON_HOME,	'Z' },
+	{ PAD_TRIGGER_L,	WPAD_BUTTON_MINUS,	'L' },
+	{ PAD_TRIGGER_R,	WPAD_BUTTON_PLUS,	'R' },
+	{ PAD_BUTTON_LEFT,	WPAD_BUTTON_LEFT,	KEY_KP4 },
+	{ PAD_BUTTON_RIGHT,	WPAD_BUTTON_RIGHT,	KEY_KP6 },
+	{ PAD_BUTTON_UP,	WPAD_BUTTON_UP,		KEY_KP8 },
+	{ PAD_BUTTON_DOWN,	WPAD_BUTTON_DOWN,	KEY_KP2 }
+};
+
+void get_screen_size() {
+}
+
+void getch2_enable() {
+	getch2_status=1;
+}
+
+void getch2_disable() {
+	getch2_status=0;
+}
+
+void getch2(void) {
+	static s64 lt = 0;
+	s64 tt;
+	u16 pad, i;
+	u32 wpad;
+	bool mod;
+
+	if (!getch2_status)
+		return;
+
+	if (reset_pressed || power_pressed) {
+		mplayer_put_key(KEY_CLOSE_WIN);
+		return;
+	}
+
+	tt = gettime();
+	if (ticks_to_millisecs(tt - lt) < (TB_MSPERSEC / 60))
+		return;
+
+	lt = tt;
+	mod = false;
+
+	PAD_ScanPads();
+
+	pad = PAD_ButtonsDown(0);
+	if (PAD_ButtonsHeld(0) & PAD_BUTTON_Y)
+		mod = true;
+
+	WPAD_ScanPads();
+
+	wpad = 0;
+	if (WPAD_Probe (0, NULL) == WPAD_ERR_NONE) {
+		wpad = WPAD_ButtonsDown(0);
+		if (WPAD_ButtonsHeld(0) & WPAD_BUTTON_2)
+			mod = true;
+	}
+
+	if (mod) {
+		for (i = 0; i < sizeof (pad_maps_mod) / sizeof (pad_map); ++i)
+			if ((pad & pad_maps_mod[i].pad) || (wpad & pad_maps_mod[i].wpad)) {
+				mplayer_put_key(pad_maps_mod[i].key);
+				return;
+			}
+	} else {
+		for (i = 0; i < sizeof (pad_maps) / sizeof (pad_map); ++i)
+			if ((pad & pad_maps[i].pad) || (wpad & pad_maps[i].wpad)) {
+				mplayer_put_key(pad_maps[i].key);
+				return;
+			}
+	}
+}
+
+#ifdef HAVE_ICONV
+char* get_term_charset(void) {
+	static const char *codepage = "ASCII";
+
+	return codepage;
+}
+#endif
+
Index: osdep/timer-gekko.c
===================================================================
--- osdep/timer-gekko.c	(revision 0)
+++ osdep/timer-gekko.c	(revision 0)
@@ -0,0 +1,58 @@
+/*
+   MPlayer timer for Wii
+
+   Copyright (C) 2008 dhewg
+
+   This library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2 of the License, or (at your option) any later version.
+
+   This library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with this library; if not, write to the
+   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+   Boston, MA 02110-1301 USA.
+*/
+
+
+#include <unistd.h>
+
+#include <ogc/lwp_watchdog.h>
+
+const char *timer_name = "gekko";
+
+int usec_sleep(int usec_delay) {
+	return usleep(usec_delay);
+}
+
+unsigned int GetTimer(void) {
+	return ticks_to_microsecs(gettime());
+}
+
+unsigned int GetTimerMS(void) {
+	return ticks_to_millisecs(gettime());
+}
+
+static s64 relative = 0;
+
+float GetRelativeTime(void) {
+	s64 t;
+	float res;
+
+	t = gettime();
+	res = (float) ticks_to_nanosecs(diff_ticks(relative, t)) /
+			(float) TB_NSPERSEC;
+	relative = t;
+
+	return res;
+}
+
+void InitTimer(void) {
+	relative = gettime();
+}
+
Index: osdep/log_console.c
===================================================================
--- osdep/log_console.c	(revision 0)
+++ osdep/log_console.c	(revision 0)
@@ -0,0 +1,189 @@
+/*-------------------------------------------------------------
+
+Copyright (C) 2008 dhewg
+
+This software is provided 'as-is', without any express or implied
+warranty.  In no event will the authors be held liable for any
+damages arising from the use of this software.
+
+Permission is granted to anyone to use this software for any
+purpose, including commercial applications, and to alter it and
+redistribute it freely, subject to the following restrictions:
+
+1.	The origin of this software must not be misrepresented; you
+must not claim that you wrote the original software. If you use
+this software in a product, an acknowledgment in the product
+documentation would be appreciated but is not required.
+
+2.	Altered source versions must be plainly marked as such, and
+must not be misrepresented as being the original software.
+
+3.	This notice may not be removed or altered from any source
+distribution.
+
+-------------------------------------------------------------*/
+
+#include <sys/iosupport.h>
+#include <reent.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "log_console.h"
+
+static bool gecko = false;
+static const devoptab_t *dot_video = NULL;
+static VIRetraceCallback rcb = NULL;
+static char **log = NULL;
+static u16 log_size = 0;
+static u16 log_next = 0;
+static bool log_active = true;
+static bool video_active = true;
+
+static int __out_write(struct _reent *r, int fd, const char *ptr, int len) {
+	u32 level;
+	u16 l;
+
+	if (!ptr || len <= 0)
+		return -1;
+
+	if (video_active) {
+		dot_video->write_r(r, fd, ptr, len);
+	} else {
+		if (log_active) {
+			l = (log_next + 1) % log_size;
+			if (log[l])
+				free(log[l]);
+			log[l] = strndup(ptr, len);
+
+			log_next = l;
+		}
+	}
+
+	if (gecko) {
+		level = IRQ_Disable();
+		usb_sendbuffer(1, ptr, len);
+		IRQ_Restore(level);
+	}
+
+	return len;
+}
+
+const devoptab_t dot_out = {
+	"stdout",	// device name
+	0,			// size of file structure
+	NULL,		// device open
+	NULL,		// device close
+	__out_write,// device write
+	NULL,		// device read
+	NULL,		// device seek
+	NULL,		// device fstat
+	NULL,		// device stat
+	NULL,		// device link
+	NULL,		// device unlink
+	NULL,		// device chdir
+	NULL,		// device rename
+	NULL,		// device mkdir
+	0,			// dirStateSize
+	NULL,		// device diropen_r
+	NULL,		// device dirreset_r
+	NULL,		// device dirnext_r
+	NULL,		// device dirclose_r
+	NULL		// device statvfs_r
+};
+
+void log_console_init(GXRModeObj *vmode, u16 logsize) {
+	u16 i;
+
+	CON_InitEx(vmode, 20, 30, vmode->fbWidth - 40, vmode->xfbHeight - 60);
+	rcb = VIDEO_SetPostRetraceCallback(NULL);
+	VIDEO_SetPostRetraceCallback(rcb);
+
+	gecko = usb_isgeckoalive(1);
+
+	if (log_size && log) {
+		for (i = 0; i < log_size; ++i)
+			if (log[i])
+				free(log[i]);
+
+		free(log);
+	}
+
+	log_size = logsize;
+	log_next = 0;
+
+	if (log_size) {
+		log = (char **) malloc(log_size * sizeof(char *));
+
+		for (i = 0; i < log_size; ++i)
+			log[i] = NULL;
+	}
+
+	log_active = log_size > 0;
+
+	dot_video = devoptab_list[STD_OUT];
+	video_active = true;
+
+	devoptab_list[STD_OUT] = &dot_out;
+	devoptab_list[STD_ERR] = &dot_out;
+}
+
+void log_console_deinit(void) {
+	u16 i;
+
+	if (log_size && log) {
+		for (i = 0; i < log_size; ++i)
+			if (log[i])
+				free(log[i]);
+
+		free(log);
+		log = NULL;
+	}
+
+	log_size = 0;
+	log_next = 0;
+
+	devoptab_list[STD_OUT] = dot_video;
+	devoptab_list[STD_ERR] = dot_video;
+
+	VIDEO_SetPostRetraceCallback(rcb);
+
+	dot_video = NULL;
+}
+
+void log_console_enable_log(bool enable) {
+	if (!log_size)
+		return;
+
+	log_active = enable;
+}
+
+void log_console_enable_video(bool enable) {
+	struct _reent *r = _REENT;
+	u16 i, l;
+
+	if (video_active == enable)
+		return;
+
+	video_active = enable;
+
+	if (enable)
+		VIDEO_SetPostRetraceCallback(rcb);
+	else
+		VIDEO_SetPostRetraceCallback(NULL);
+
+	if (!enable || !log_size)
+		return;
+
+	for (i = 0; i < log_size; ++i) {
+		l = (log_next + 1 + i) % log_size;
+		if (log[l]) {
+			dot_video->write_r(r, 0, log[l], strlen(log[l]));
+			free(log[l]);
+			log[l] = NULL;
+		}
+	}
+
+	fflush(stdout);
+}
+
Index: osdep/log_console.h
===================================================================
--- osdep/log_console.h	(revision 0)
+++ osdep/log_console.h	(revision 0)
@@ -0,0 +1,36 @@
+/*-------------------------------------------------------------
+
+Copyright (C) 2008 dhewg
+
+This software is provided 'as-is', without any express or implied
+warranty.  In no event will the authors be held liable for any
+damages arising from the use of this software.
+
+Permission is granted to anyone to use this software for any
+purpose, including commercial applications, and to alter it and
+redistribute it freely, subject to the following restrictions:
+
+1.	The origin of this software must not be misrepresented; you
+must not claim that you wrote the original software. If you use
+this software in a product, an acknowledgment in the product
+documentation would be appreciated but is not required.
+
+2.	Altered source versions must be plainly marked as such, and
+must not be misrepresented as being the original software.
+
+3.	This notice may not be removed or altered from any source
+distribution.
+
+-------------------------------------------------------------*/
+
+#ifndef _LOG_CONSOLE_H_
+#define _LOG_CONSOLE_H_
+
+#include <gccore.h>
+
+void log_console_init(GXRModeObj *vmode, u16 logsize);
+void log_console_deinit(void);
+void log_console_enable_log(bool enable);
+void log_console_enable_video(bool enable);
+
+#endif
Index: osdep/plat_gekko.c
===================================================================
--- osdep/plat_gekko.c	(revision 0)
+++ osdep/plat_gekko.c	(revision 0)
@@ -0,0 +1,185 @@
+/*
+   MPlayer Wii port
+
+   Copyright (C) 2008 dhewg
+
+   This library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2 of the License, or (at your option) any later version.
+
+   This library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with this library; if not, write to the
+   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+   Boston, MA 02110-1301 USA.
+*/
+
+#include "../config.h"
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+
+#include <ogcsys.h>
+#include <ogc/lwp_watchdog.h>
+#include <debug.h>
+#include <wiiuse/wpad.h>
+
+#include <fat.h>
+#include <di/di.h>
+
+#include "log_console.h"
+#include "gx_supp.h"
+#include "plat_gekko.h"
+
+#undef abort
+
+bool ios_reloaded = true;
+bool reset_pressed = false;
+bool power_pressed = false;
+
+static char *default_args[] = {
+	"mplayer.dol",
+	"-loop", "0",
+	"-menu",
+	"-menu-startup",
+	"loop.mov"
+};
+
+static void reset_cb (void) {
+	reset_pressed = true;
+}
+
+static void power_cb (void) {
+	power_pressed = true;
+}
+
+int gekko_gettimeofday(struct timeval *tv, void *tz) {
+	u32 us = ticks_to_microsecs(gettime());
+
+	tv->tv_sec = us / TB_USPERSEC;
+	tv->tv_usec = us % TB_USPERSEC;
+
+	return 0;
+}
+
+void gekko_abort(void) {
+	printf("abort() called\n");
+	plat_deinit(-1);
+	exit(-1);
+}
+
+DIR *opendir(const char *name) {
+	return diropen(name);
+}
+
+static struct dirent de;
+
+struct dirent *readdir(DIR *dir) {
+	struct stat st;
+
+	if (dirnext(dir, de.d_name, &st))
+		return NULL;
+
+	return &de;
+}
+
+int closedir(DIR *dir) {
+	return dirclose(dir);
+}
+
+void plat_init (int *argc, char **argv[]) {
+	char buf[MAXPATHLEN];
+
+	DI_Init();
+	VIDEO_Init();
+	PAD_Init();
+
+	AUDIO_Init(NULL);
+	AUDIO_RegisterDMACallback(NULL);
+	AUDIO_StopDMA();
+
+	SYS_SetResetCallback (reset_cb);
+	SYS_SetPowerCallback (power_cb);
+
+#if 0
+	DEBUG_Init(0, 1);
+	_break();
+#endif
+
+	GX_InitVideo();
+
+	log_console_init(vmode, 128);
+	printf("MPlayer Wii port (c) 2008 Team Twiizers\n");
+	printf("Running under IOS%d\n", IOS_GetVersion());
+	printf("VIDEO: %u * %u (%u * %u)\n", vmode->fbWidth, vmode->efbHeight,
+			vmode->viWidth, vmode->viHeight);
+
+	if (!ios_reloaded) {
+		printf("IOS could not be reloaded, exiting.\n");
+		sleep(3);
+
+		exit(0);
+	}
+
+	WPAD_Init();
+	WPAD_SetDataFormat(WPAD_CHAN_0, WPAD_FMT_BTNS);
+	WPAD_SetIdleTimeout(180);
+
+	if (!fatInitDefault()) {
+		printf("fatInitDefault failed\n");
+		sleep(3);
+
+		exit(0);
+	}
+
+	fatEnableReadAhead(PI_DEFAULT, 32, 128);
+
+	getcwd(buf, MAXPATHLEN);
+	if (!strcmp(buf, "fat:/")) {
+		strcpy(buf, "/apps/mplayer");
+		chdir(buf);
+	}
+
+	setenv("HOME", buf, 1);
+	setenv("DVDCSS_CACHE", "off", 1);
+	setenv("DVDCSS_VERBOSE", "2", 1);
+
+	if (*argc < 2) {
+		*argc = sizeof(default_args) / sizeof(char *);
+		*argv = default_args;
+	}
+}
+
+void plat_deinit (int rc) {
+	DI_Close();
+
+	if (!fatUnmount(PI_DEFAULT)) {
+		printf ("fatUnmount failed\n");
+		fatUnsafeUnmount(PI_DEFAULT);
+	}
+
+	if (power_pressed) {
+		printf("shutting down\n");
+		SYS_ResetSystem(SYS_POWEROFF, 0, 0);
+	}
+
+	log_console_enable_video(true);
+
+	VIDEO_WaitVSync();
+
+	if (vmode->viTVMode & VI_NON_INTERLACE)
+		VIDEO_WaitVSync();
+
+	if (rc != 0)
+		sleep(3);
+
+	log_console_deinit();
+}
+
Index: osdep/plat_gekko.h
===================================================================
--- osdep/plat_gekko.h	(revision 0)
+++ osdep/plat_gekko.h	(revision 0)
@@ -0,0 +1,48 @@
+#ifndef __PLAT_GEKKO_H__
+#define __PLAT_GEKKO_H__
+
+#ifdef GEKKO
+
+#include <sys/time.h>
+#include <sys/dir.h>
+#include <unistd.h>
+
+#include <gctypes.h>
+
+extern bool reset_pressed;
+extern bool power_pressed;
+
+// yeah, i know...
+// there is no _FILE_OFFSET_BITS in newlib and mplayer expects a 64bit off_t,
+// so thats what it gets
+#define off_t s64
+
+#define PATH_MAX MAXPATHLEN
+
+typedef DIR_ITER DIR;
+
+struct dirent {
+	//ino_t d_ino;
+	//off_t d_off;
+	//unsigned short d_reclen;
+	//unsigned char  d_type;
+	char d_name[MAXPATHLEN];
+};
+
+int gekko_gettimeofday(struct timeval *tv, void *tz);
+
+void gekko_abort(void);
+
+#define gettimeofday(TV, TZ) gekko_gettimeofday((TV), (TZ))
+#define abort(x) gekko_abort(x)
+
+DIR *opendir(const char *name);
+struct dirent *readdir(DIR *dir);
+int closedir(DIR *dir);
+
+void plat_init (int *argc, char **argv[]);
+void plat_deinit (int rc);
+
+#endif
+
+#endif
